︠684db23a-2c1b-4d4b-9725-1f0bcd053bd2i︠
%hide
def stock_load(kil):
    s=file(DATA+'germ.txt')
    stock=s.readlines()
    i=0
    f1=[]
    nmax=len(stock)
    while (i<(kil))and(i<nmax):
        v=float(stock[i])
        f1.append(v)
        i=i+1
    s.close()
    series=finance.TimeSeries(f1)
    return series
︡41ca3a89-94e1-4202-b4d7-0a2a4a4ee9ac︡︡
︠9e01ac09-3059-49ba-9385-bb510e48c272i︠
%hide
def GeneralMinSquare(X,Y,POWERS):
    nn=min(len(X),len(Y)) 
    X=vector(X) #экспериментальные 
    Y=vector(Y)
    Y=Y.transpose() 
    XX=matrix(RR,nn,POWERS+1) #матрица эксперимента 
    for i in range(0,nn): 
        for j in range(0,POWERS+1):
            XX[i,j]=X[i]^(POWERS-j) 
    R=((XX.transpose()*XX)^(-1))*(XX.transpose()*Y)
    R=R.list()
    R1=R[::-1]
    return R1
︡a30da566-a63a-4a20-bdf6-955427818029︡︡
︠4a80d030-29a4-45f7-9c59-fe19e317e274i︠
%hide
def GetPoly(A,X):
    nn=len(A)
    nX=len(X)
    RES=[]
    for j in range (0,nX):
        kk=0
        for i in range(0,nn):
            kk=kk+A[i]*(X[j]^i)
        RES.append (kk)
    return RES
︡95ff23c8-b4c1-4db7-bc6e-8a6f2a227bda︡︡
︠5ba62989-8042-4717-bba9-e06791a8982ci︠
%hide
def MFDFAScales(START,END,kind,value,koeff):
    RES=[]
    current=0
    stepScale=0
    if kind=="STEP":
        RES.append(START)
        current=START+value
        index=1
        while(current<END):
            RES.append(current)
            index=index+1
            current=current+value
    if kind=="RATIO":     
        RES.append(START)
        index=1
        value=koeff
        current=floor(START*value)
        if current==START: current=START+1
        while (current<END):
            RES.append(current)
            index=index+1
            current=floor(current*value)
            if (current==RES[index-1]):
                current=current+1
    if kind=="nSTEP":      
        RES=[]
        RES.append(START)
        stepScale=floor((END-START)/float(value))
        current=START+stepScale;
        index=1
        while(index<value):
            RES.append(current)
            index=index+1
            current=current+stepScale
    if kind=="nRATIO":
        k=(float(END)/START)^(1/(value-1))
        RES=[]
        RES.append(START)
        RES.append(START)
        index=2
        while (index<(value)):
            current=floor(RES[index-1]*k)
            if (current==RES[index-1]): RES.append(RES[index-1]+1)
            else: RES.append(current)
            k1=(float(END)/RES[index])^(1/(value-index+1))
            if (k1>k): k=k1
            index=index+1
        RES.append(END)
        RES.remove(RES[1]);
    return RES
︡e3c90804-8701-4f43-83ec-badba69bcb26︡︡
︠acba3790-102d-48d2-84c2-4cb3b865a1d8i︠
%hide
def MFDFAOneStep(Y,S,ORDER):
    n=len(Y)
    Ns=floor(n/S)
    windowBegin=0
    windowEnd=S
    index=0
    XtStart=[]
    Yt=[]
    F2=[]
    kk=0
    while kk<Ns:
        F2.append(0)
        kk=kk+1
    i=0
    while i<windowEnd:
            XtStart.append(i)
            i=i+1
    while (windowEnd<=n):
        i=windowBegin
        Yt=[]
        while i<windowEnd:
            Yt.append(Y[i])
            i=i+1
        A=GeneralMinSquare(XtStart,Yt,ORDER)
        YPoly=GetPoly(A,XtStart)
        ff=0
        sum=0
        TEMP=0
        while ff<len(YPoly):
            TEMP=TEMP+((Yt[ff]-YPoly[ff])^2)
            ff=ff+1
        F2[index]=(TEMP/float(S))
        windowBegin=windowBegin+S
        windowEnd=windowEnd+S
        index=index+1
    if (windowBegin!=n):
        kk=len(F2)
        ss=kk+Ns
        while kk<ss:
            F2.append(0)
            kk=kk+1
        windowBegin=n-S
        windowEnd=n
        XtStart=[]
        Yt=[]
        i=0
        while i<S:
            XtStart.append(i)
            i=i+1
        i=windowBegin  
        while (windowBegin>=0):
            Yt=[]
            i=windowBegin
            while i<windowEnd:
                Yt.append(Y[i])
                i=i+1
            A=GeneralMinSquare(XtStart,Yt,ORDER)
            YPoly=GetPoly(A,XtStart)
            ff=0
            sum=0
            TEMP=0
            while ff<len(YPoly):
                TEMP=TEMP+((Yt[ff]-YPoly[ff])^2)
                ff=ff+1
            F2[index]=(TEMP/float(S))
            windowBegin=windowBegin-S
            windowEnd=windowEnd-S
            index=index+1
        Ns=Ns*2
    return F2,Ns
︡ce839bf7-5f9b-4d66-8762-bb94213bb255︡︡
︠28c7a1ef-439d-4ad8-8bda-73b20cadab53i︠
%hide
def MFDFA(X,windowWidthBegin,windowWidthEnd,POWERS,DFAORDER,kindOfElevate,valueOfElevate,koef):
    #print windowWidthBegin,windowWidthEnd,POWERS,DFAORDER,kindOfElevate,valueOfElevate,koef
    AVG=X.mean()
    i=0
    n=len(X)
    sum=0
    Y=[]
    while i<n:
        sum=sum+X[i]-AVG
        Y.append(sum)
        i=i+1  
    Y=finance.TimeSeries(Y)
    max=Y.abs().max()
    Y=Y.scale(1/max)
    S=MFDFAScales(windowWidthBegin,windowWidthEnd,kindOfElevate,valueOfElevate,koef)
    ns=len(S)
    #print S
    Q=POWERS
    nq=len(Q)
    FqS=matrix(RR,nq,ns)
    indexS=0
    F2=[]
    F2t2=0
    Ns=0
    currentS=0
    while indexS<ns:
        currentS=S[indexS]
        F2,Ns=MFDFAOneStep(Y,currentS,DFAORDER)
        for currentQ in range(0,nq):
            cQ=Q[currentQ]
            F2t2=0
            z=0
            while z<len(F2):
                F2t2=((F2[z])^(cQ/2.0))+F2t2
                z=z+1
            F2t2=(F2t2/float(Ns))
            xxx=((F2t2)^(1.0/float(cQ)))
            FqS[currentQ,indexS]=xxx
        indexS=indexS+1
    return S,FqS,Q
︡c6b4fa53-a19b-43a6-be9a-098c6f5dc8f7︡︡
︠c8a0e24d-f0be-416a-854e-a0f2204517d7︠
def MFDFAHTau(S,FqS,Q):
   i=0
   lS=[]
   lFqS=[]
   print FqS[1,1]
   while i<len(S):
       lS.append(log(S[i]))
       i=i+1
   row=FqS.nrows()
   col=FqS.ncols()
   lFqS=matrix(RR,row,col)
   for i in range (0,row):
       for j in range (0,col):
           lFqS[i,j]=RR(log(FqS[i,j]))
           lFqS[i,j]=lFqS[i,j]
   Hq=vector(RR,{(row-1):0})
   TAUq=vector(RR,{(row-1):0})
   g=1
   for i in range (0,row):
       temp=[]
       for j in range (0,col):
           temp.append(lFqS[i,j])
       A=GeneralMinSquare(lS,temp,g)
       Hq[i]=A[1]
       TAUq[i]=(Q[i]*Hq[i]-1)
   Q1=vector(Q).transpose()    
   return Hq,TAUq,Q1
︡104b3db6-8519-4ae3-ba9a-602234168421︡︡
︠7481ba56-d59a-4f95-805a-4b602de1f9a1i︠
%hide
def natural_spline(X,DATA):
    prec=16
    m=0 
    N = len(X) 
    a = mrange_iter([range(N)], sum) 
    alpha = mrange_iter([range(N)], sum) 
    b = mrange_iter([range(N)], sum) 
    c = mrange_iter([range(N)], sum) 
    d = mrange_iter([range(N)], sum) 
    h = mrange_iter([range(N)], sum) 
    l = mrange_iter([range(N)], sum) 
    mu = mrange_iter([range(N)], sum) 
    z = mrange_iter([range(N)], sum) 
    S = mrange_iter([range(N)], sum) 
    a = DATA 
    h[0] = X[1] - X[0] 
    l[0] = 1 
    mu[0] = 0 
    z[0] = 0 
    for n in range(1, N-1): 
 #       print n
        h[n] = X[n+1] - X[n] 
        alpha[n] = 3.0/h[n]*(a[n+1] - a[n]) - 3.0/h[n-1]*(a[n] - a[n-1]) 
        l[n] = 2*(X[n+1] - X[n-1]) - h[n-1]*mu[n-1] 
        mu[n] = h[n]/float(l[n])
        z[n] = (alpha[n] - h[n-1]*z[n-1])/float(l[n])
        n = N -1 
        c[n] = 0 
        l[n] = 1 
        z[n] = 0 
        n = n-1 
        while n >= 0: 
            c[n] = (z[n] - mu[n]*c[n+1])
            b[n] = ((a[n+1] - a[n])/float(h[n]) - h[n]*(c[n+1] +2*c[n])/3.0)
            d[n] = ((c[n+1] - c[n])/(3.0*h[n]))
            S[n] = a[n] + b[n]*(x - X[n]) + c[n]*(x - X[n])^2 + d[n]*(x-X[n])^3 
            n = n-1 
    return [X,S]
︡4a4e42ee-86cc-4d9e-8f5e-d25f9fc49801︡︡
︠6a418db6-a5d6-4063-9ae8-608f5345d366i︠
%hide
def calc_spline(xs,xx):
    yy=0
    for i in range(0, len(xs[0])):
        if xx>=xs[0][i]:
            yy=xs[1][i].subs(x=xx)
            i=len(xs[0])
    return yy
︡39cb2b13-163b-4525-ac00-059013b61b4e︡︡
︠38ebb58c-da0b-4881-873a-b5e62a107effi︠
%hide
def calc_dspline(xs,xx):
    yy=0
    for i in range(0, len(xs[0])):
        if xx>=xs[0][i]:
            ff=diff(xs[1][i],x)
            yy=ff.subs(x=xx)
            i=len(xs[0])
    return yy
︡3f3e69ae-664c-4c74-b4f0-7b0cd344af87︡︡
︠759482be-e2e1-4600-9b72-eaba32def3e0︠
def MFDFAAlphaFTAUSpline(Q,TAUq,percFunction):
   # Мультифрактальний DFA (MF-DFA) за статтею
   # "Multifractal detrended fluctuation analysis of nonstationary time series"
   # Визначення alpha та F(alpha)
   # Аргументи:
   # Q          - вектор-рядок значень q
   # Hq         - вектор-рядок значень tau(q)
   # Результати:
   #   ALPHA      - значення аргументів ALPHA
   #   FALPHA     - значення функції F(alpha)
   # визначимо кількість значень Q
   nQ=len(Q)
   
   # якщо Q має більше одного рядка - транспонуємо
   if (nQ==1):
       Q=vector(Q).transpose()
       nQ=len(Q)
   # визначимо кількість значень TAUq    
   nTau=len(TAUq)
   
   # якщо TAUq має більше одного рядка - транспонуємо
   if (nTau==1):
       TAUq=vector(TAUq).transpose()
       nTau=len(TAUq)
   
   # створюємо два нульових вектора ALPHA та FALPHA    
   ALPHA =vector(RR,{(nQ):0})
   FALPHA=vector(RR,{(nQ):0})
   ALPHA2 =vector(RR,{(nQ):0})
   FALPHA2=vector(RR,{(nQ):0})
   # знаходимо alpha
 
   PP=natural_spline(Q,TAUq)
   for i in range(1,nQ-1):
       ALPHA[i]=calc_dspline(PP,float(Q[i]))
       
       #ALPHA[i] = (TAUq[i]-TAUq[i-1])/float(Q[i]-Q[i-1])
       FALPHA[i]=Q[i]*ALPHA[i]-TAUq[i]
       #print ALPHA[i],FALPHA[i]
   if (percFunction!=0):
       maxFALPHA=percFunction/100.0*float(max(FALPHA))
       nA=len(FALPHA)
       ALPHA2 =[]
       FALPHA2=[]
       for i in range(0,nA):
          if (FALPHA[i]>=maxFALPHA):
               FALPHA2.append(FALPHA[i])
               ALPHA2.append(ALPHA[i])
   return ALPHA2,FALPHA2
︡3843c239-ee11-4241-b122-6ea7ef3967ab︡︡
︠f6f57e3b-1dc2-42b7-a94c-982e158abfeai︠
%hide
def MFDFAAlphaFHSpline(Q,Hq,percFunction):
    # Мультифрактальний DFA (MF-DFA) за статтею
    # "Multifractal detrended fluctuation analysis of nonstationary time series"
    # Визначення alpha та F(alpha)
    # Аргументи:
    # Q          - вектор-рядок значень q
    # Hq         - вектор-рядок значень h(q)
    # Результати:
    #   ALPHA      - значення аргументів ALPHA
    #   FALPHA     - значення функції F(alpha)
    # визначимо кількість значень Q
    nQ=len(Q)
    #if (nQ==1):
    #    Q=vector(Q).transpose()
    #    nQ=len(Q)
    # визначимо кількість значень TAUq    
    nHq=len(Hq)
    FA=0
    # якщо Hq має більше одного рядка - транспонуємо
    #if (nHq==1):
    #    nHq=vector(Hq).transpose()
    #    nHq=len(Hq)
    ALPHA1=vector(RR,{(nQ):0})
    FALPHA1=vector(RR,{(nQ):0})
    # знаходимо alpha
    #print Hq
    #print Q
    PP=natural_spline(Q,Hq)
    ALPHA1[0]=calc_dspline(PP,Q[0])*Q[0]+Hq[0]
    for i in range(1,nQ):
        ALPHA1[i]=Hq[i]+calc_dspline(PP,Q[i])*Q[i]
        FALPHA1[i]=Q[i]*(ALPHA1[i-1]-Hq[i])+1
        #print ALPHA1[i],FALPHA1[i]
    if (percFunction!=0):
        maxFALPHA=percFunction/100.0*max(FALPHA1)
        nA=len(FALPHA1)
        ALPHA11 =[]
        FALPHA11=[]
        FA=0
        for i in range(0,nA):
           if (FALPHA1[i]>=maxFALPHA):
               FALPHA11.append(FALPHA1[i])
               ALPHA11.append(ALPHA1[i])
    return ALPHA11,FALPHA11
︡4cdf4fe1-7e2d-40f0-9fb7-e0c8250b2865︡︡
︠44401099-9ad9-43eb-a30b-1dd36f446004︠
@interact
def f(kil=input_box(default="10000",label="Кількість значень"),
    windowWidthBegin=input_box(default="10",label="Початкова ширина сегмента"),
    windowWidthEnd=input_box(default="1000",label="Кінцева ширина сегмента"),
    POWERSedit=input_box(default="[-3,0.1,3]",label="Степені q для розрахунку DFA"),
    DFAORDER=input_box(default="2",label="Порядок DFA"),
    valueOfElevate=input_box(default="100",label="Кількість вікон при кроці"),
    koef=input_box(default="100",label="Коефіцієнт збільшення вікна"),
    percFunction=input_box(default="90",label="Відсоток збільшення вікна"),
    kindOfElevate=selector(["","nSTEP","nRATIO","STEP","RATIO"],label="Тип збільшення вікна",buttons=True),
    ):       
        global gl;
        gl=0
        kil=int(kil)
        windowWidthBegin=int(windowWidthBegin)
        windowWidthEnd=int(windowWidthEnd)
        POWERSedit=[-3,0.1,3]
        DFAORDER=int(DFAORDER)
        valueOfElevate=int(valueOfElevate)
        koef=int(koef)
        percFunction=int(percFunction)
        if (kil=='' or windowWidthBegin=='' or windowWidthEnd=='' or POWERSedit=='' \
        or len(POWERSedit)<3 or DFAORDER=='' or valueOfElevate=='' or koef==""\
        or kindOfElevate=="" or percFunction==''): 
            print "Введіть всі поля даних"
            return 0
        X=stock_load(kil)
        X=finance.TimeSeries(X)
        xx=vector(POWERSedit)  
        index=xx[0]
        POWERS=[]
        while (index<=xx[2]+10^-13):
            if abs(index)>10^-13: POWERS.append(float(index))
            index=index+xx[1]
       
        S,FqS,Q=MFDFA(X,windowWidthBegin,windowWidthEnd,POWERS,\
        DFAORDER,kindOfElevate,valueOfElevate,koef)
        FqS2=FqS.transpose()
        nq=FqS.nrows()
        ns=FqS.ncols()
        html("Розподілення Fq(s)") 
        r1=[]
        for i in range (0,ns):
            for j in range (0,nq):
                r1.append([log(S[i],10).n(digits=10),log(FqS2[i][j],10).n(digits=10)])
        point(r1).show()
        Hq,TAUq,Q2=MFDFAHTau(S,FqS,Q)
        #розподілення Hq
        html("Розподілення H(q)") 
        r1=[]
        for i in range (0,len(Hq)):
            r1.append([Q2[i][0],Hq[i]])
        point(r1).show()
        #розподілення TAUq
        html("Розподілення Tau(q)")
        r1=[]
        for i in range (0,len(TAUq)):
            r1.append([Q2[i][0],TAUq[i]])
            #print Q2[i][0],TAUq[i]
        point(r1).show()
        ALPHA, FALPHA=MFDFAAlphaFTAUSpline(Q,TAUq,percFunction)
        html("Розподілення F(alpha), alpha розрахована через tau")
        r1=[]
        for i in range (0,len(ALPHA)):
            r1.append([ALPHA[i],FALPHA[i]])
        point(r1).show()
        ALPHA, FALPHA=MFDFAAlphaFHSpline(Q,Hq,percFunction)
        html("Розподілення F(alpha), alpha розрахована через tau")
        r1=[]
        for i in range (0,len(ALPHA)):
            r1.append([ALPHA[i],FALPHA[i]])
        point(r1).show()
︡7b092df0-d8cf-4320-ba64-4765e25655c7︡{"html": ""}︡
︠7104f64a-c529-4160-98c7-fdb66ebcc168︠
res=[]
res.append(23)
print res[0]
︡2dc2b535-53cb-4552-a7c2-2a64978f9a8e︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_27.py\", line 9, in <module>\n    exec compile(ur'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"cmVzPVtdCnJlcy5hcHBlbmQoMjMpCnByaW50IHJlc1sxXQ==\"),globals())+\"\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmpp1nsbF/___code___.py\", line 5, in <module>\n    exec compile(ur'print res[_sage_const_1 ]' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \nIndexError: list index out of range"}︡
︠930108f8-284d-4eeb-bb19-e223563e8391︠
st.plot()
︡b5f2a0d3-5a38-4740-b290-124df3e0afba︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_23.py\", line 9, in <module>\n    exec compile(ur'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"c3QucGxvdCgp\"),globals())+\"\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmpxdsPCz/___code___.py\", line 2, in <module>\n    exec compile(ur'st.plot()' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \nNameError: name 'st' is not defined"}︡
